Bug 1870890 - Review Request: chatty - mobile libpurple messaging client
Summary: Review Request: chatty - mobile libpurple messaging client
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: mobility
TreeView+ depends on / blocked
 
Reported: 2020-08-20 23:41 UTC by Nikhil Jha
Modified: 2020-10-31 23:17 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---


Attachments (Terms of Use)

Description Nikhil Jha 2020-08-20 23:41:54 UTC
Spec URL: https://gitlab.com/fedora-mobile/chatty/-/raw/master/chatty.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/njha/mobile/fedora-33-x86_64/01619181-chatty/chatty-0.1.15-1.fc33.src.rpm
Description: A mobile libpurple messaging client
Fedora Account System Username: njha

This package has a hack that (AFAIK???) is technically not against the packaging guidelines. We can either keep this hack, or alternatively use this hack: https://src.fedoraproject.org/rpms/pidgin/pull-request/3

Upstream (both pidgin and purism) have said that they can't fix it on their end. If someone has a better solution, please let me know :)

Comment 1 Nikhil Jha 2020-08-20 23:42:21 UTC
(oh, and as always, here's a COPR build https://copr.fedorainfracloud.org/coprs/njha/mobile/build/1619181/)

Comment 2 Robert-André Mauchin 🐧 2020-08-26 23:16:20 UTC
 - Be more specific than %{_datadir}/*

%{_datadir}/glib-2.0/schemas/sm.puri.Chatty.gschema.xml
%{_datadir}/applications/sm.puri.Chatty.desktop
%{_datadir}/icons/hicolor/*/apps/sm.puri.Chatty*.svg
%{_metainfodir}/sm.puri.Chatty.metainfo.xml
%dir %{_datadir}/bash-completion
%dir %{_datadir}/bash-completion/completions
%{_datadir}/bash-completion/completions/chatty

 - Validate the desktop and appdata file. Add %meson_test.

BuildRequires:  libappstream-glib
BuildRequires:  desktop-file-utils

[…]

%check
appstream-util validate-relax --nonet \
        %{buildroot}%{_metainfodir}/*.appdata.xml
desktop-file-validate \
        %{buildroot}/%{_datadir}/applications/sm.puri.Chatty.desktop
%meson_test

 - I don't understand what you're doing with libjabber, especially why you are copying it to the buildroot and install it in %files. Isn't this file provided by libpurple?


/usr/lib64/purple-2/libjabber.so.0
/usr/lib64/purple-2/libjabber.so.0.0.0

Why is it not in the provides list?


 - Requires hicolor-icon-theme to own the icons directory.

 - /etc/ → %{_sysconfdir}

 - Handle the lang file properly with  %find_lang

%find_lang purism-chatty

[…]

%files -f purism-chatty.lang
%{_bindir}/chatty

 - Delete the rpath:

chatty.x86_64: E: binary-or-shlib-defines-rpath /usr/bin/chatty ['/tmp']

It's located at the end of src/meson.build

 - Don't mix tabs and spaces:

chatty.src:8: W: mixed-use-of-spaces-and-tabs (spaces: line 8, tab: line 3)

 - Add a comment above the patch explaining why it is neded





Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs a %{name}.desktop using desktop-file-install or desktop-
  file-validate if there is such a file.


===== MUST items =====

C/C++:
[x]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[!]: Rpath absent or only used for internal libs.
     Note: See rpmlint output
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[x]: License file installed when any subpackage combination is installed.
[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/share/applications(filesystem, java-runtime-decompiler, racket),
     /usr/share/bash-completion(mtr, tio, dconf-editor, rkt, golang-github-
     tdewolff-minify, eg, driverctl, tealdeer, zeitgeist, exa, awscli,
     restic, maven, python-django-bash-completion, unar, yadifa-tools,
     nitrokey-app, flatpak, subversion, cmake-data, licensecheck, lightdm,
     ModemManager, lxi-tools, mercurial-py3, policycoreutils, source-
     highlight, gpaste, docker-compose, cowsay, ethtool, pdfgrep, vagrant,
     reprepro, hyperfine, zola, ffsend, skim, mercurial-py2, clufter-cli,
     falkon, buildah, fd-find, dotnet-host, gammu, python3-catkin_tools,
     etckeeper, dnf, lxc, tracker, rtags, git-annex, stress-ng, fedpkg,
     bash-completion, beaker-client, breezy, devscripts-checkbashisms,
     toolbox, pbuilder, exercism, swaylock, ldc, swayidle, rpmlint,
     cobbler, libqmi, filesystem, fedmod, bodhi-client, docopt, devscripts,
     clevis, git-delta, chocolate-doom, stratis-cli, task, python3-trezor,
     git-core, libmbim, the_silver_searcher, wlogout, sway, datamash, nnn,
     zypper, skopeo, bubblewrap, rpmdevtools, kmod, glib2, rpmspectool,
     calf, ripgrep, cpu-x, yadifa, darcs, hstr), /usr/share/bash-
     completion/completions(lastpass-cli, libnbd-bash-completion, mtr, tio,
     dconf-editor, rkt, libguestfs-bash-completion, golang-github-tdewolff-
     minify, eg, driverctl, tealdeer, zeitgeist, kompose, exa, awscli,
     restic, firewalld, maven, python-django-bash-completion, ndctl, unar,
     yadifa-tools, nitrokey-app, firejail, flatpak, subversion, cmake-data,
     licensecheck, lightdm, ModemManager, lxi-tools, nordugrid-arc-client,
     mercurial-py3, source-highlight, gpaste, docker-compose, cowsay,
     ethtool, pdfgrep, vagrant, reprepro, hyperfine, zola, ffsend, skim,
     mercurial-py2, clufter-cli, falkon, calibre, buildah, fd-find, dotnet-
     host, gammu, GMT-common, python3-catkin_tools, etckeeper, dnf, lxc,
     tracker, rtags, git-annex, xss-lock, stress-ng, fedpkg, bash-
     completion, gtatool, beaker-client, breezy, devscripts-checkbashisms,
     toolbox, pbuilder, exercism, swaylock, ldc, swayidle, rpmlint, opensc,
     cobbler, libqmi, filesystem, fedmod, minipro, bodhi-client,
     coccinelle-bash-completion, docopt, devscripts, python3-pip, tig,
     clevis, git-delta, packit, chocolate-doom, stratis-cli, libappstream-
     glib, task, python3-trezor, git-core, libmbim, the_silver_searcher,
     wlogout, sway, datamash, nnn, zypper, skopeo, bubblewrap, rpmdevtools,
     nbdkit-bash-completion, kmod, glib2, rpmspectool, calf, ripgrep,
     cpu-x, yadifa, darcs, hstr), /usr/share/glib-2.0(unity-gtk-module-
     common, glib2), /usr/share/glib-2.0/schemas(unity-gtk-module-common,
     glib2), /usr/share/icons(filesystem),
     /usr/share/icons/hicolor(wesnoth-data, qtl866, kgraphviewer, qmmp,
     qucs, fedora-logos, pdfmod, massif-visualizer, mono-tools, xchm,
     redeclipse, vim-X11, tuxanci, swappy, hicolor-icon-theme,
     freedroidrpg, android-file-transfer, autokey-common, nedit, wdisplays,
     vacuum-im), /usr/share/icons/hicolor/scalable(autokey-common, fedora-
     logos, qtl866, pdfmod, keepassx, massif-visualizer, tuxanci,
     dxf2gcode, swappy, eom, hicolor-icon-theme, wdisplays, freedroidrpg,
     lxqt-powermanagement, qmmp, qucs),
     /usr/share/icons/hicolor/scalable/apps(autokey-common, fedora-logos,
     qtl866, pdfmod, keepassx, massif-visualizer, tuxanci, dxf2gcode,
     swappy, eom, hicolor-icon-theme, wdisplays, freedroidrpg, gtatool-gui,
     qmmp, qucs), /usr/share/icons/hicolor/symbolic(hicolor-icon-theme),
     /usr/share/icons/hicolor/symbolic/apps(hicolor-icon-theme),
     /usr/share/locale(filesystem), /usr/share/locale/cs(filesystem),
     /usr/share/locale/cs/LC_MESSAGES(filesystem),
     /usr/share/locale/da(filesystem),
     /usr/share/locale/da/LC_MESSAGES(filesystem),
     /usr/share/locale/de(filesystem),
     /usr/share/locale/de/LC_MESSAGES(filesystem),
     /usr/share/locale/de_DE(filesystem),
     /usr/share/locale/de_DE/LC_MESSAGES(filesystem),
     /usr/share/locale/el(filesystem),
     /usr/share/locale/el/LC_MESSAGES(filesystem),
     /usr/share/locale/en_GB(filesystem),
     /usr/share/locale/en_GB/LC_MESSAGES(filesystem),
     /usr/share/locale/es(filesystem),
     /usr/share/locale/es/LC_MESSAGES(filesystem),
     /usr/share/locale/fi(filesystem),
     /usr/share/locale/fi/LC_MESSAGES(filesystem),
     /usr/share/locale/fr(filesystem),
     /usr/share/locale/fr/LC_MESSAGES(filesystem),
     /usr/share/locale/hu(filesystem),
     /usr/share/locale/hu/LC_MESSAGES(filesystem),
     /usr/share/locale/it(filesystem),
     /usr/share/locale/it/LC_MESSAGES(filesystem),
     /usr/share/locale/it_IT(filesystem),
     /usr/share/locale/it_IT/LC_MESSAGES(filesystem),
     /usr/share/locale/ja(filesystem),
     /usr/share/locale/ja/LC_MESSAGES(filesystem),
     /usr/share/locale/la(filesystem),
     /usr/share/locale/la/LC_MESSAGES(filesystem),
     /usr/share/locale/pl(filesystem),
     /usr/share/locale/pl/LC_MESSAGES(filesystem),
     /usr/share/locale/pt_BR(filesystem),
     /usr/share/locale/pt_BR/LC_MESSAGES(filesystem),
     /usr/share/locale/ro(filesystem),
     /usr/share/locale/ro/LC_MESSAGES(filesystem),
     /usr/share/locale/ru(filesystem),
     /usr/share/locale/ru/LC_MESSAGES(filesystem),
     /usr/share/locale/sk(filesystem),
     /usr/share/locale/sk/LC_MESSAGES(filesystem),
     /usr/share/locale/tr(filesystem),
     /usr/share/locale/tr/LC_MESSAGES(filesystem),
     /usr/share/locale/uk(filesystem),
     /usr/share/locale/uk/LC_MESSAGES(filesystem),
     /usr/share/metainfo(filesystem, lutris, gsequencer, mailnag)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: chatty-0.1.15-1.fc34.x86_64.rpm
          chatty-debuginfo-0.1.15-1.fc34.x86_64.rpm
          chatty-debugsource-0.1.15-1.fc34.x86_64.rpm
          chatty-0.1.15-1.fc34.src.rpm
chatty.x86_64: W: spelling-error Summary(en_US) libpurple -> lib purple, lib-purple, purple
chatty.x86_64: W: spelling-error %description -l en_US libpurple -> lib purple, lib-purple, purple
chatty.x86_64: W: spelling-error %description -l en_US phosh -> phish, posh, phosphor
chatty.x86_64: E: binary-or-shlib-defines-rpath /usr/bin/chatty ['/tmp']
chatty.x86_64: W: non-conffile-in-etc /etc/xdg/autostart/sm.puri.Chatty-daemon.desktop
chatty.x86_64: E: standard-dir-owned-by-package /usr/share/icons
chatty.x86_64: W: no-manual-page-for-binary chatty
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/cs/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/da/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/de/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/de_DE/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/el/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/en_GB/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/es/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/fi/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/fr/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/hu/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/it/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/it_IT/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/ja/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/la/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/pl/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/pt_BR/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/ro/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/ru/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/sk/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/tr/LC_MESSAGES/purism-chatty.mo
chatty.x86_64: W: file-not-in-%lang /usr/share/locale/uk/LC_MESSAGES/purism-chatty.mo
chatty.src: W: spelling-error Summary(en_US) libpurple -> lib purple, lib-purple, purple
chatty.src: W: spelling-error %description -l en_US libpurple -> lib purple, lib-purple, purple
chatty.src: W: spelling-error %description -l en_US phosh -> phish, posh, phosphor
chatty.src:60: W: macro-in-comment %{_datadir}
chatty.src:8: W: mixed-use-of-spaces-and-tabs (spaces: line 8, tab: line 3)
chatty.src: E: specfile-error warning: Macro expanded in comment on line 60: %{_datadir}/glib-2.0/schemas/sm.puri.chatty.gschema.xml
4 packages and 0 specfiles checked; 3 errors, 31 warnings.

Comment 3 Torrey Sorensen 2020-10-16 20:37:46 UTC
Spec URL: https://gitlab.com/fedora-mobile/chatty/-/raw/master/chatty.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/njha/mobile/fedora-33-x86_64/01710020-chatty/chatty-0.1.16-2.fc33.src.rpm

>  - I don't understand what you're doing with libjabber, especially why you are copying it to the buildroot and install it in %files. Isn't this file provided by libpurple?

It is not provided by libpurple, unless this PR here is merged to *not* remove the symlink: https://src.fedoraproject.org/rpms/pidgin/pull-request/3


Review items have been addressed, successful build here in copr: https://copr.fedorainfracloud.org/coprs/njha/mobile/build/1710020/

Comment 4 Elliott Sales de Andrade 2020-10-31 22:01:31 UTC
Looks like a duplicate of bug 1757674; you may want to discuss with that packager.

Comment 5 Nikhil Jha 2020-10-31 23:17:04 UTC
(In reply to Elliott Sales de Andrade from comment #4)
> Looks like a duplicate of bug 1757674; you may want to discuss with that
> packager.

Thanks! Already did this a few months ago. They said they don’t have time to work on
that package anymore so the mobility sig is taking it over.


Note You need to log in before you can comment on or make changes to this bug.